DECLARE SUB DetectSettings (BasePort%, IRQ%, LoDMA%, HiDMA%, CardType%)
DECLARE SUB DriversLoaded (SBMIDI%, SBSIM%)
DECLARE SUB LoadandPlayMIDI (Filename$, MIDISegment%, MIDIOffset%)
DECLARE FUNCTION MIDIError$ ()
DECLARE FUNCTION MixerChip$ ()
DECLARE SUB SetCard (CardType%)
DECLARE FUNCTION SoundCard$ (CardType%)
DECLARE SUB StopMidi ()
DECLARE FUNCTION InternalBitRead% (Variable%, BitNum%)
DECLARE SUB InternalBitSet (Variable%, BitNum%, OnOff%)
DECLARE SUB InternalBitToggle (Variable%, BitNum%)
DECLARE SUB InternalGetIntVector (IntNum%, segment%, offset%)
DECLARE SUB InternalGetVol (LeftChannel%, RightChannel%, Index%)
DECLARE SUB InternalSetVol (LeftChannel%, RightChannel%, Index%)
DECLARE SUB InternalWriteMixer (Index%, Value%)
DECLARE FUNCTION InternalReadMixer% (Index%)
'$INCLUDE: 'dash.bi'
DIM SHARED MIDI.ERROR AS INTEGER, SBSIM.INTERRUPT AS INTEGER
DIM SHARED MIDI.LOADED AS INTEGER, SBMIDI.INTERRUPT AS INTEGER
DIM SHARED MIXER.CHIP AS INTEGER, SB.BASEPORT AS INTEGER, SB.IRQ AS INTEGER
DIM SHARED SB.LODMA AS INTEGER, SB.HIDMA AS INTEGER, SB.CARDTYPE AS INTEGER
DIM SHARED BIT.STORAGE(0 TO 7) AS INTEGER, SENSITIVE AS INTEGER
DIM SHARED REVERSE.STEREO AS INTEGER, SOUND.DISABLED AS INTEGER
DIM SHARED mario%(16104), buffer&(15999), Array%(24694)
DIM tiles%(12999), map(127, 31) AS STRING * 1
DIM map2(127, 31) AS STRING * 1

INPUT "Do you want to use a Gravis Pad? (y/n) ", a$
IF UCASE$(a$) <> "Y" THEN gravis% = 0 ELSE gravis% = 1
INPUT "Do you want music? (y/n) ", a$
IF UCASE$(a$) <> "Y" THEN music% = 0 ELSE music% = 1

IF music% = 1 THEN
   DriversLoaded SBMIDI.INTERRUPT, SBSIM.INTERRUPT
   IF SBMIDI.INTERRUPT = 0 THEN SBMIDI.INTERRUPT = &H80
   DriversLoaded SBMIDI%, SBSIM%
   IF SBMIDI% = 0 THEN
      PRINT
      PRINT "SBMidi is not loaded."
      PRINT "You must run SMW:Clone through M$-DOS."
      PRINT "To load SBMidi, type SBMIDI at the prompt, then rerun the game."
      END
   END IF
END IF

mapy% = 19
DEF SEG = VARSEG(map(0, 0))
BLOAD "level1.map", VARPTR(map(0, 0))
DEF SEG = VARSEG(map2(0, 0))
BLOAD "level1bg.map", VARPTR(map2(0, 0))

SCREEN 13
IF music% = 1 THEN
   DetectSettings SB.BASEPORT, SB.IRQ, SB.LODMA, SB.HIDMA, SB.CARDTYPE
   IF SB.CARDTYPE = 0 THEN SetCard 2
   IF SB.BASEPORT = 0 THEN SB.BASEPORT = &H220
   IF SB.IRQ = 0 THEN SB.IRQ = 5
   IF SB.LODMA = 0 THEN SB.LODMA = 1
   IF SB.HIDMA = 0 AND SB.CARDTYPE = 6 THEN SB.HIDMA = 5
   LoadandPlayMIDI "smwintro.mid", VARSEG(Array%(0)), VARPTR(Array%(0))
END IF

VSPalette ""
DEF SEG = VARSEG(mario%(0))
BLOAD "mario.pic", VARPTR(mario%(0))
PUT (0, 0), mario%, PSET

FOR b% = 0 TO 3
   FOR a% = 0 TO 12
      GET (a% * 16, b% * 32)-(a% * 16 + 15, b% * 32 + 31), mario%(258 * a% + 3354 * b%)
   NEXT
NEXT
DEF SEG = VARSEG(tiles%(0))
BLOAD "level1.pic", VARPTR(tiles%(0))
PUT (0, 0), tiles%, PSET
FOR a% = 0 TO 99
   GET ((a% * 16) MOD 160, 16 * (a% \ 10))-((a% * 16 + 15) MOD 160, 16 * (a% \ 10) + 15), tiles%(a% * 130)
NEXT

x% = 160
char% = 0
song% = 0
   FOR a% = 19 TO -1 STEP -1
      FOR b% = 0 TO 12
         VSPut32 VARSEG(tiles%(0)), VARPTR(tiles%(130 * ASC(map2((a% + s% \ 4 + 31) MOD 31, (b% + 32) MOD 15 + 17)))), a% * 16 + (s% \ 4) MOD 16 + 8, b% * 16, VARSEG(buffer&(0)), VARPTR(buffer&(0))
      NEXT
   NEXT
   FOR a% = -1 TO 19
      FOR b% = 0 TO 13
         VSSprite VARSEG(tiles%(0)), VARPTR(tiles%(130 * ASC(map((a% + s% + 128) MOD 128, (b% + 19) MOD 32)))), a% * 16 - (s% \ 2) MOD 16, b% * 16 - 4, VARSEG(buffer&(0)), VARPTR(buffer&(0))
      NEXT
   NEXT
VSSprite VARSEG(mario%(0)), VARPTR(mario%(0)), 160, 140, VARSEG(buffer&(0)), VARPTR(buffer&(0))
VSPCopy VARSEG(buffer&(0)), VARPTR(buffer&(0)), &HA000, 0
DEF SEG = VARSEG(buffer&(0))
BLOAD "smwtitle.pic", VARPTR(buffer&(0))
VSPCopyT VARSEG(buffer&(0)), VARPTR(buffer&(0)), &HA000, 0
VSUnFadeBlack "mario"
IF gravis% = 0 THEN joy% = 0: joy2% = 0: button% = 0
SLEEP 2
DO UNTIL keyinp% = 1
   keyinp% = INP(&H60)
   VSClearKB
   IF gravis% <> 0 THEN
      OUT &H201, &HFF: DO: LOOP UNTIL INP(&H201) <> &HFF
      joy% = INP(&H201) XOR &HF0
      OUT &H201, &HFF: DO: LOOP UNTIL INP(&H201) <> &HFF
      joy2% = INP(&H201) XOR &HF0
      button% = INP(&H201)
   END IF
   FOR a% = 19 TO -1 STEP -1
      FOR b% = 0 TO 12
         VSPut32 VARSEG(tiles%(0)), VARPTR(tiles%(130 * ASC(map2((a% + s% \ 4 + 31) MOD 31, (b% + 32) MOD 15 + 17)))), a% * 16 + (s% \ 4) MOD 16 + 8, b% * 16, VARSEG(buffer&(0)), VARPTR(buffer&(0))
      NEXT
   NEXT
   FOR a% = -1 TO 19
      FOR b% = 0 TO 12
         VSSprite VARSEG(tiles%(0)), VARPTR(tiles%(130 * ASC(map((a% + s% \ 2 + 128) MOD 128, (b% + 19) MOD 32)))), a% * 16 + (s% \ 2) MOD 16, b% * 16 - 4, VARSEG(buffer&(0)), VARPTR(buffer&(0))
      NEXT
   NEXT
   anim% = (anim% + 1) MOD 24
   IF anim% MOD 8 = 0 THEN
      FOR b% = 0 TO 31
         FOR a% = 0 TO 127
            IF ASC(map(a%, b%)) >= 29 AND ASC(map(a%, b%)) <= 31 THEN
               map(a%, b%) = CHR$(29 + anim% \ 8)
            ELSEIF ASC(map(a%, b%)) >= 34 AND ASC(map(a%, b%)) <= 36 THEN
               map(a%, b%) = CHR$(34 + anim% \ 8)
            END IF
         NEXT
      NEXT
   END IF
   IF jump% <= 20 THEN
      y% = 40 + (jump% - 10) ^ 2
   END IF
  
   IF jump% = 1 AND flip% = 1 THEN flip% = 2
  
   IF jump% > 0 THEN jump% = (jump% + 1) MOD 21
  
   IF jump% > 0 THEN
      IF spin% = 0 THEN
         IF jump% > 10 THEN IF mar% = 3 OR mar% = 10 THEN mar% = mar% + 1
         IF jump% = 20 THEN
            spin% = 0
            IF mar% = 11 THEN mar% = 7 ELSE mar% = 0
            IF flip% = 2 THEN flip% = 0
         END IF
      ELSEIF spin% = 1 THEN
         IF jump% MOD 4 = 0 THEN mar% = 0 ELSE mar% = (jump% MOD 4) + 4
      END IF
   END IF
   IF flip% = 2 THEN
      IF mar% <= 5 THEN
         VSSpriteR VARSEG(mario%(0)), VARPTR(mario%(mar% * 258 + 3354 * char%)), x% + 4, y% + 16, CosTable%(jump% * 16), SinTable%(jump% * 16), VARSEG(buffer&(0)), VARPTR(buffer&(0))
      ELSE
         VSSpriteR VARSEG(mario%(0)), VARPTR(mario%(mar% * 258 + 3354 * char%)), x% + 4, y% + 16, -CosTable%((jump% * 16 + 180) MOD 360), SinTable%((jump% * 16 + 180) MOD 360), VARSEG(buffer&(0)), VARPTR(buffer&(0))
      END IF
   ELSE
      VSSprite VARSEG(mario%(0)), VARPTR(mario%(mar% * 258 + 3354 * char%)), x%, y%, VARSEG(buffer&(0)), VARPTR(buffer&(0))
   END IF
  
   IF (HEX$(joy%) = "D" AND HEX$(joy2%) = "E") OR keyinp% = 77 THEN
      IF jump% = 0 THEN
         IF mar% <= 5 THEN
            x% = x% + 4: IF x% > 280 THEN x% = 280: s% = s% + 1: IF s% = 161 THEN s% = 160
            mar% = ((x% + s%) MOD 12) \ 4
         ELSE
            mar% = 5
         END IF
      ELSE
         x% = x% + 4: IF x% > 280 THEN x% = 280: s% = s% + 1: IF s% = 161 THEN s% = 160
         mar% = 3
      END IF
   ELSEIF (HEX$(joy%) = "E" AND HEX$(joy2%) = "E") OR keyinp% = 75 THEN
      IF jump% = 0 THEN
         IF mar% >= 5 THEN
            x% = x% - 4: IF x% < 24 THEN x% = 24: s% = s% - 1: IF s% = -1 THEN s% = 0
            mar% = ((x% + s%) MOD 12) \ 4 + 7
         ELSE
            mar% = 5
         END IF
      ELSE
         x% = x% - 4: IF x% < 24 THEN x% = 24: s% = s% - 1: IF s% = -1 THEN s% = 0
         mar% = 10
      END IF
   ELSEIF button% = &HBF OR keyinp% = 44 THEN
      IF flip% = 0 AND jump% >= 15 THEN flip% = 1
      spin% = 0: IF jump% = 0 THEN jump% = 1
      IF mar% > 6 THEN mar% = 10 ELSE mar% = 3
   ELSEIF button% = &HEF OR keyinp% = 30 THEN
      FOR a% = 19 TO -1 STEP -1
         FOR b% = 0 TO 12
            VSPut32 VARSEG(tiles%(0)), VARPTR(tiles%(130 * ASC(map2((a% + s% \ 4 + 31) MOD 31, (b% + 32) MOD 15 + 17)))), a% * 16 + (s% \ 4) MOD 16 + 8, b% * 16, VARSEG(buffer&(0)), VARPTR(buffer&(0))
         NEXT
      NEXT
      FOR a% = -1 TO 19
         FOR b% = 0 TO 12
            VSSprite VARSEG(tiles%(0)), VARPTR(tiles%(130 * ASC(map((a% + s% \ 2 + 128) MOD 128, (b% + 19) MOD 32)))), a% * 16 + (s% \ 2) MOD 16, b% * 16 - 4, VARSEG(buffer&(0)), VARPTR(buffer&(0))
         NEXT
      NEXT
      VSSprite VARSEG(mario%(0)), VARPTR(mario%(3096 + 3354 * char%)), x%, y%, VARSEG(buffer&(0)), VARPTR(buffer&(0))
      VSPCopy VARSEG(buffer&(0)), VARPTR(buffer&(0)), &HA000, 0
      VSDelay 10
      char% = (char% + 1) MOD 4
   ELSEIF button% = &HDF OR keyinp% = 31 THEN
      spin% = 1: IF jump% = 0 THEN jump% = 1
   ELSEIF (button% = &H7F OR keyinp% = 45) AND music% = 1 THEN
      song% = (song% + 1) MOD 6
      StopMidi
      IF song% = 0 THEN a$ = "sm64slid"
      IF song% = 1 THEN a$ = "sm64fly"
      IF song% = 2 THEN a$ = "sm64snow"
      IF song% = 3 THEN a$ = "sm64watr"
      IF song% = 4 THEN a$ = "sm64metl"
      IF song% = 5 THEN a$ = "sm64end"
      LoadandPlayMIDI a$ + ".mid", VARSEG(Array%(0)), VARPTR(Array%(0))
   END IF
   VSPCopy VARSEG(buffer&(0)), VARPTR(buffer&(0)), &HA000, 0
LOOP
IF music% = 1 THEN StopMidi
VSFadeBlack 100

REM $DYNAMIC
SUB DetectSettings (BasePort%, IRQ%, LoDMA%, HiDMA%, CardType%)

BasePort% = 0
IRQ% = 0
LoDMA% = 0
HiDMA% = 0
CardType% = 0

Settings$ = ENVIRON$("BLASTER")

FOR I% = 1 TO LEN(Settings$) - 1
    SELECT CASE UCASE$(MID$(Settings$, I%, 1))
        CASE "T"
            CardType% = VAL(MID$(Settings$, I% + 1, 1))
        CASE "A"
            BasePort% = VAL("&H" + LTRIM$(STR$(VAL(MID$(Settings$, I% + 1, 3)))))
        CASE "I"
            IRQ% = VAL(MID$(Settings$, I% + 1, 2))
        CASE "D"
            LoDMA% = VAL(MID$(Settings$, I% + 1, 1))
        CASE "H"
            HiDMA% = VAL(MID$(Settings$, I% + 1, 1))
    END SELECT
NEXT I%

IF CardType% = 0 THEN
    SELECT CASE LoDMA%
        'If the DMA is 210h or 230h, the card is an SB1.0/1.5.
        CASE &H210, &H230
            CardType% = 1
        'If the DMA is 250h or 260h, the card is either an SB2CD or a
        'Sound Blaster 16.  It could also be a Sound Blaster 1.0/1.5,
        'but it probably isn't.  Actually, it's also unlikely that the card
        'is an SB16, but I check for it anyway, because there's an easy way
        'to tell if it is - the High DMA channel will be greater than 0.
        '
        'On the other hand, there's no way that I know of to
        'distinguish an SB 1.0 from an SB 2.0, except by looking at the
        'BLASTER environment variable.  And since this code is executing
        'that method obviously failed.
        CASE &H250, &H260
            'Examining the High DMA channel will narrow it down.
            'If the High DMA is greater than 0, the card is an SB16.
            IF HiDMA% THEN
                CardType% = 6
            'Otherwise, define the card as a Sound Blaster 2.0.
            ELSE
                CardType% = 3
            END IF
        'If the DMA channel is any other value....
        CASE ELSE
            'Check the High DMA channel.  If it's a non-zero value,
            'we've got an SB16.
            IF HiDMA% THEN
                CardType% = 6
            'Otherwise....
            ELSE
                'If sensitive error checking is on, define the card as
                'a Sound Blaster 1.0/1.5.
                IF SENSITIVE THEN
                    CardType% = 1
                'Otherwise, assume it's a Sound Blaster Pro.
                ELSE
                    CardType% = 4
                END IF
            END IF
    END SELECT
END IF

'Determine the sound card's mixer chip
SELECT CASE CardType%
    'If the card could not be detected....
    CASE 0
        MIDI.ERROR = 7
        'If sensitive error checking is on, disable mixer operations
        IF SENSITIVE THEN
            MIXER.CHIP = 0
        'Otherwise, assume the default mixer chip.
        ELSE
            MIXER.CHIP = 2
        END IF
    'If the card is a Sound Blaster 1.0/1.5 or equivalent....
    CASE 1
        'Return an error.
        MIDI.ERROR = 6
        'If sensitive error checking is on, disable mixer operations and
        'exit.
        IF SENSITIVE THEN
            MIXER.CHIP = 0
            EXIT SUB
        'Otherwise, set the earliest mixer chip and continue.
        ELSE
            MIXER.CHIP = 1
        END IF
    'If the card is a Sound Blaster 2.0/2.5 or equivalent....
    CASE 3
        'There are two different kinds of SB 2.0 cards: the regular SB2,
        'and the SB2CD.  The SB2CD has a mixer chip (the CT1335), whereas
        'the SB 2.0 does not.  The way to tell them apart is that the
        'Sound Blaster 2.0 uses Base Ports 220h and 240h, and the SB2CD
        'uses ports 250h and 260h.
        '
        'Assume the sound card is an SB2CD for now...
        MIXER.CHIP = 1
        'If the card is defined as an SB 2.0, not an SB 2.0 CD, and
        'sensitive error checking is on, disable mixer operations.
        IF (BasePort% = &H220 OR BasePort% = &H240) AND SENSITIVE <> 0 THEN
            MIXER.CHIP = 0
        END IF
        MIDI.ERROR = 0
    'If the card is a Sound Blaster Pro, assume chip CT1345
    CASE 2, 4, 5
        MIXER.CHIP = 2
        MIDI.ERROR = 0
    'If the card is a Sound Blaster 16 or later, assume chip CT1745
    CASE IS >= 6
        MIXER.CHIP = 3
        MIDI.ERROR = 0
END SELECT
END SUB

SUB DriversLoaded (SBMIDI%, SBSIM%) STATIC
ff% = FREEFILE
OPEN "DRIVERS.DAT" FOR BINARY AS #ff%
FileSize& = LOF(ff%)
IF FileSize& = 0 THEN
    CLOSE ff%
    KILL "DRIVERS.DAT"
    MIDI.ERROR = 1
    EXIT SUB
ELSEIF FileSize& <> 1024 THEN
    CLOSE ff%
    MIDI.ERROR = 9
    EXIT SUB
END IF
REDIM DRIVERDATA$(1 TO 5)
FOR I% = 1 TO 4
    DRIVERDATA$(I%) = INPUT$(256, #ff%)
NEXT I%
CLOSE #ff%

SBMIDI% = 0
SBSIM% = 0
FOR I% = &H80 TO &HE1
    InternalGetIntVector I%, segment%, offset%
    'If the address is null, then the interrupt is not in use, and can be
    'skipped.
    IF segment% = 0 AND offset% = 0 THEN GOTO Skip:
    'The following code checks for the drivers by looking for the text
    '"SBMIDI" and "SBSIM" at certain locations in the driver code.  It
    'sounds simplistic, but it's very accurate.  If it doesn't work,
    'a different method is used.
    IF SBMIDI% = 0 THEN
        NewSegment% = CVI(MKI$(CVL(MKI$(segment%) + CHR$(0) + CHR$(0)) - &H11&))
        DEF SEG = NewSegment%
        temp$ = ""
        FOR J% = 1 TO 6
            temp$ = temp$ + CHR$(PEEK(271 + J%))
        NEXT
        IF temp$ = "SBMIDI" THEN SBMIDI% = I%
    END IF
    IF SBSIM% = 0 THEN
        NewSegment% = CVI(MKI$(CVL(MKI$(segment%) + CHR$(0) + CHR$(0)) - &H1&))
        DEF SEG = NewSegment%
        temp$ = ""
        FOR J% = 1 TO 5
            temp$ = temp$ + CHR$(PEEK(274 + J%))
        NEXT
        IF temp$ = "SBSIM" THEN SBSIM% = I%
    END IF
  
    'This is the second detection method.  It's more complex than the first
    'method, but not really any more accurate.  In fact, it's probably
    'less accurate.  It's kind of a last ditch effort in case the first
    'method fails.

    'Point to the segment of the interrupt handler.
    DEF SEG = segment%
    'Read 256 bytes of the driver code.
    DRIVERDATA$(5) = ""
    FOR J% = 0 TO 255
        Byte% = PEEK(offset% + J%)
        DRIVERDATA$(5) = DRIVERDATA$(5) + CHR$(Byte%)
    NEXT J%
    'Check to see if the code matches any of the previously saved data.
    FOR J% = 1 TO 4
        MATCH% = 1
        FOR K% = 0 TO 255
            IF MID$(DRIVERDATA$(J%), K% + 1, 1) <> MID$(DRIVERDATA$(5), K% + 1, 1) THEN
                SELECT CASE K%
                    CASE IS = 14, 15, 113, 114, 235, 236
                    CASE ELSE
                        MATCH% = 0
                        EXIT FOR
                END SELECT
            END IF
        NEXT K%
        IF MATCH% THEN
            IF J% = 1 THEN SBSIM% = I%
            IF J% <> 1 THEN SBMIDI% = I%
        END IF
        IF SBSIM% <> 0 AND SBMIDI% <> 0 THEN EXIT FOR
    NEXT J%
    IF SBSIM% <> 0 AND SBMIDI% <> 0 THEN EXIT FOR
Skip:
NEXT I%
MIDI.ERROR = 0
END SUB

FUNCTION InternalBitRead% (Variable%, BitNum%)
VarSegment% = VARSEG(Variable%)
offset% = VARPTR(Variable%)
DEF SEG = VarSegment%
InternalBitRead% = -((PEEK(offset% + BitNum% \ 8) AND 2 ^ (BitNum% MOD 8)) > 0)
END FUNCTION

SUB InternalBitSet (Variable%, BitNum%, OnOff%)
VarSegment% = VARSEG(Variable%)
offset% = VARPTR(Variable%)
DEF SEG = VarSegment%
IF OnOff% THEN
    POKE offset% + BitNum% \ 8, PEEK(offset% + BitNum% \ 8) OR 2 ^ (BitNum% MOD 8)
ELSE
    POKE offset% + BitNum% \ 8, PEEK(offset% + BitNum% \ 8) AND 255 - 2 ^ (BitNum% MOD 8)
END IF
END SUB

SUB InternalBitToggle (Variable%, BitNum%)
VarSegment% = VARSEG(Variable%)
offset% = VARPTR(Variable%)
DEF SEG = VarSegment%
POKE offset% + BitNum% \ 8, PEEK(offset% + BitNum% \ 8) XOR 2 ^ (BitNum% MOD 8)
END SUB

SUB InternalGetIntVector (IntNum%, segment%, offset%) STATIC
'If the code hasn't been loaded already, do it now.
IF GetIntVCodeLoaded% = 0 THEN
    asm$ = CHR$(&H55) + CHR$(&H89) + CHR$(&HE5) + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA)
    asm$ = asm$ + CHR$(&H8A) + CHR$(&H7) + CHR$(&HB4) + CHR$(&H35)
    asm$ = asm$ + CHR$(&HCD) + CHR$(&H21) + CHR$(&H8C) + CHR$(&HC1) + CHR$(&H89) + CHR$(&HDA)
    asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8) + CHR$(&H89) + CHR$(&HF)
    asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)
    asm$ = asm$ + CHR$(&H89) + CHR$(&H17) + CHR$(&H5D) + CHR$(&HCB)
    asm$ = asm$ + CHR$(&H34) + CHR$(&H0) + CHR$(&H60) + CHR$(&H23) + CHR$(&H0)
    GetIntVCodeLoaded% = 1
END IF
DEF SEG = VARSEG(asm$)
CALL ABSOLUTE(IntNum%, segment%, offset%, SADD(asm$))
END SUB

FUNCTION InternalReadMixer% (Index%)
OUT SB.BASEPORT + 4, Index%
InternalReadMixer% = INP(SB.BASEPORT + 5)
END FUNCTION

SUB InternalSetVol (LeftChannel%, RightChannel%, Index%)
SELECT CASE MIXER.CHIP
    CASE 0: EXIT SUB
    CASE 1
        IF LeftChannel% > -1 AND LeftChannel% < 32 THEN
            LeftChannel% = LeftChannel% \ 4
            IF LeftChannel% > 7 THEN LeftChannel% = 7
            Volume% = InternalReadMixer%(2)
            FOR I% = 0 TO 2
                BIT.STORAGE(I%) = InternalBitRead%(LeftChannel%, I%)
                IF BIT.STORAGE(I%) THEN
                    InternalBitSet Volume%, I% + 1, 1
                END IF
            NEXT I%
            InternalWriteMixer Index%, Volume%
        END IF
    CASE 2
        Volume% = InternalReadMixer%(Index%)
        LeftChannel% = LeftChannel% \ 4
        IF LeftChannel% > 7 THEN LeftChannel% = 7
        RightChannel% = RightChannel% \ 4
        IF RightChannel% > 7 THEN RightChannel% = 7
        IF REVERSE.STEREO THEN SWAP LeftChannel%, RightChannel%
        FOR I% = 0 TO 2
            BIT.STORAGE(I%) = InternalBitRead%(RightChannel%, I%)
            IF RightChannel% > -1 AND RightChannel% < 32 THEN
                IF BIT.STORAGE(I%) THEN BitVal% = 1 ELSE BitVal% = 0
                InternalBitSet Volume%, I% + 1, BitVal%
            END IF
            BIT.STORAGE(I%) = InternalBitRead%(LeftChannel%, I%)
            IF LeftChannel% > -1 AND LeftChannel% < 32 THEN
                IF BIT.STORAGE(I%) THEN BitVal% = 1 ELSE BitVal% = 0
                InternalBitSet Volume%, I% + 5, BitVal%
            END IF
        NEXT I%
        InternalWriteMixer Index%, Volume%
    CASE 3
        LVolume% = InternalReadMixer%(Index%)
        RVolume% = InternalReadMixer%(Index% + 1)
        IF REVERSE.STEREO THEN SWAP LeftChannel%, RightChannel%
        FOR I% = 0 TO 4
            BIT.STORAGE(I%) = InternalBitRead%(RightChannel%, I%)
            IF RightChannel% > -1 AND RightChannel% < 32 THEN
                IF BIT.STORAGE(I%) THEN BitVal% = 1 ELSE BitVal% = 0
                InternalBitSet RVolume%, I% + 3, BitVal%
            END IF
            BIT.STORAGE(I%) = InternalBitRead%(LeftChannel%, I%)
            IF LeftChannel% > -1 AND LeftChannel% < 32 THEN
                IF BIT.STORAGE(I%) THEN BitVal% = 1 ELSE BitVal% = 0
                InternalBitSet LVolume%, I% + 3, BitVal%
            END IF
        NEXT I%
        InternalWriteMixer Index%, LVolume%
        InternalWriteMixer Index% + 1, RVolume%
END SELECT

END SUB

SUB InternalWriteMixer (Index%, Value%)
OUT SB.BASEPORT + 4, Index%
OUT SB.BASEPORT + 5, Value%
END SUB

SUB LoadandPlayMIDI (Filename$, MIDISegment%, MIDIOffset%) STATIC
IF SBMIDI.INTERRUPT < &H80 AND SENSITIVE <> 0 THEN MIDI.ERROR = 4: EXIT SUB
ff% = FREEFILE
OPEN Filename$ FOR BINARY AS #ff%
FileLen& = LOF(ff%)
CLOSE #ff%
IF FileLen& = 0 THEN KILL Filename$: MIDI.ERROR = 1: EXIT SUB
IF FileLen& > 65536 THEN MIDI.ERROR = 2: EXIT SUB
Filename$ = Filename$ + CHR$(0)
IF asm1$ = "" THEN
        asm1$ = CHR$(&H1E) + CHR$(&H55) + CHR$(&H89) + CHR$(&HE5)
        asm1$ = asm1$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H3D)
        asm1$ = asm1$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HE) + CHR$(&H8B) + CHR$(&H17)
        asm1$ = asm1$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H10)
        asm1$ = asm1$ + CHR$(&H8E) + CHR$(&H1F) + CHR$(&HCD) + CHR$(&H21)
        asm1$ = asm1$ + CHR$(&H89) + CHR$(&HC6) + CHR$(&HB4) + CHR$(&H3F)
        asm1$ = asm1$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8) + CHR$(&H8B) + CHR$(&HF)
        asm1$ = asm1$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA) + CHR$(&H8B) + CHR$(&H17)
        asm1$ = asm1$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HC)
        asm1$ = asm1$ + CHR$(&H8E) + CHR$(&H1F) + CHR$(&H89) + CHR$(&HF3)
        asm1$ = asm1$ + CHR$(&HCD) + CHR$(&H21) + CHR$(&HB4) + CHR$(&H3E)
        asm1$ = asm1$ + CHR$(&HCD) + CHR$(&H21) + CHR$(&H5D) + CHR$(&H1F)
        asm1$ = asm1$ + CHR$(&HCA) + CHR$(&HA) + CHR$(&H0)
END IF
DEF SEG = VARSEG(asm1$)
CALL ABSOLUTE(VARSEG(Filename$), SADD(Filename$), MIDISegment%, MIDIOffset%, &HFFFF, SADD(asm1$))
IF asm2$ = "" THEN
        asm2$ = CHR$(&H55) + CHR$(&H89) + CHR$(&HE5) + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)
        asm2$ = asm2$ + CHR$(&H8B) + CHR$(&H17) + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)
        asm2$ = asm2$ + CHR$(&H8B) + CHR$(&H7) + CHR$(&HBB) + CHR$(&H4) + CHR$(&H0)
        asm2$ = asm2$ + CHR$(&HCD) + CHR$(SBMIDI.INTERRUPT)
        asm2$ = asm2$ + CHR$(&HBB) + CHR$(&H5) + CHR$(&H0)
        asm2$ = asm2$ + CHR$(&HCD) + CHR$(SBMIDI.INTERRUPT)
        asm2$ = asm2$ + CHR$(&H5D) + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)
END IF
IF SOUND.DISABLED = 0 THEN
    DEF SEG = VARSEG(asm2$)
    CALL ABSOLUTE(MIDISegment%, MIDIOffset%, SADD(asm2$))
END IF
MIDI.ERROR = 0
END SUB

FUNCTION MIDIError$
SELECT CASE MIDI.ERROR
        CASE 0: MIDIError$ = "NO ERROR"
        CASE 1: MIDIError$ = "FILE CONTAINS NO DATA"
        CASE 2: MIDIError$ = "FILE IS TOO LARGE"
        CASE 3: MIDIError$ = "NO MIDI FILE PLAYING"
        CASE 4: MIDIError$ = "INVALID SBMIDI INTERRUPT"
        CASE 5: MIDIError$ = "INVALID SBSIM INTERRUPT"
        CASE 6: MIDIError$ = "NO MIXER CHIP"
        CASE 7: MIDIError$ = "COULD NOT DETECT SOUND CARD"
        CASE 8: MIDIError$ = "FEATURE UNAVAILABLE"
        CASE 9: MIDIError$ = "FILE IS CORRUPT"
        CASE 10: MIDIError$ = "INVALID SOUND CARD TYPE"
        CASE ELSE: MIDIError$ = "UNKNOWN ERROR"
END SELECT
END FUNCTION

FUNCTION MixerChip$
SELECT CASE MIXER.CHIP
    CASE 0: MixerChip$ = "No Mixer Chip Detected"
    CASE 1: MixerChip$ = "CT1335"
    CASE 2: MixerChip$ = "CT1345"
    CASE 3: MixerChip$ = "CT1745"
    CASE ELSE: MixerChip$ = "Unknown"
END SELECT
END FUNCTION

SUB SetCard (CardType%)
IF CardType% < 1 OR CardType% > 8 THEN
    MIDI.ERROR = 10
    EXIT SUB
END IF
SB.CARDTYPE = CardType%
SELECT CASE CardType%
    CASE 1
        MIDI.ERROR = 6
        IF SENSITIVE THEN
            MIXER.CHIP = 0
            EXIT SUB
        ELSE
            MIXER.CHIP = 1
        END IF
    CASE 3
        'There are two different kinds of SB 2.0 cards: the regular SB2,
        'and the SB2CD.  The SB2CD has a mixer chip (the CT1335), whereas
        'the SB 2.0 does not.  The way to tell them apart is that the
        'Sound Blaster 2.0 uses Base Ports 220h and 240h, and the SB2CD
        'uses ports 250h and 260h.
        '
        'Assume the sound card is an SB2CD for now...
        MIXER.CHIP = 1
        'If the card is defined as an SB 2.0, not an SB 2.0 CD, and
        'sensitive error checking is on, disable mixer operations.
        IF (BasePort% = &H220 OR BasePort% = &H240) AND SENSITIVE <> 0 THEN
            MIXER.CHIP = 0
        END IF
        MIDI.ERROR = 0
    CASE 2, 4, 5
        MIXER.CHIP = 2
        MIDI.ERROR = 0
    CASE ELSE
        MIXER.CHIP = 3
        MIDI.ERROR = 0
END SELECT
END SUB

FUNCTION SoundCard$ (CardType%)
SELECT CASE CardType%
    CASE 1: SoundCard$ = "Sound Blaster 1.0/1.5"
    CASE 2: SoundCard$ = "Sound Blaster Pro"
    CASE 3: SoundCard$ = "Sound Blaster 2.0/2.0CD"
    CASE 4: SoundCard$ = "Sound Blaster Pro 2"
    CASE 5: SoundCard$ = "Sound Blaster Pro 2 (Microchannel Version)"
    CASE 6: SoundCard$ = "Sound Blaster 16/16 ASP/AWE 32"
    CASE 7, 8: SoundCard$ = "Unknown (Probably SB32/AWE64)"
    CASE ELSE: SoundCard$ = "Unknown"
END SELECT
END FUNCTION

SUB StopMidi STATIC
IF SBMIDI.INTERRUPT < &H80 AND SENSITIVE <> 0 THEN MIDI.ERROR = 4: EXIT SUB
asm$ = CHR$(&HBB) + CHR$(&H4) + CHR$(&H0) + CHR$(&HCD) + CHR$(SBMIDI.INTERRUPT) + CHR$(&HCB)
DEF SEG = VARSEG(asm$)
offset% = SADD(asm$)
CALL ABSOLUTE(offset%)
MIDI.ERROR = 0
END SUB

